import 'package:getx_extended/export.dart';

class RxPageable<T> {
  static const PAGE_SIZE = 20;
  static const DEFAULT_FIRST_PAGE = 1;

  Future<List<T>> Function(int page, int size) dataSource;
  RxList<T> source = RxList();

  RxPageable(this.dataSource) {
    refresh();
  }

  late int _currentPage;
  late bool _isEnded;
  late bool _isLoading;

  Future refresh() async {
    _currentPage = DEFAULT_FIRST_PAGE;
    _isEnded = false;
    _isLoading = false;

    await next();
  }

  Future next() async {
    if (_isEnded || _isLoading) return;
    try {
      _isLoading = true;
      final response = await dataSource(_currentPage, PAGE_SIZE);

      _currentPage == DEFAULT_FIRST_PAGE
          ? source.assignAll(response)
          : source.addAll(response);

      _currentPage += 1;
      _isEnded = PAGE_SIZE > response.length;
    } finally {
      _isLoading = false;
    }
  }
}
